﻿
# README #
This application uses the Plugin feature in the NSIWS to synchronize the MappingStore/Structure database with the DotStat data database.

## Setup ##

1. Rabbit MQ software setup  
> Either use Docker by running command `docker run -it --rm --name rabbitmq -p 5672:5672 -p 15672:15672 rabbitmq:3-management`   
> or by following the installation guide on https://www.rabbitmq.com/download.html     
> Once the installation is completed, verify that the RabbitMq service is up and running by navigating to http://localhost:15672/, the username and password are guest/guest
> In this example the default configuration settings will be used
     
2. Dotstat plugin setup 
   i. Build and publish project by running command **dotnet publish -o out**
   ii. Copy files 
    - DotStat.Transfer.Messaging.Producer.dll
    - RabbitMQ.Client.dll
    - DotStat.Common.dll
   in **out** folder to the **Plugin** folder located in the NSIWS root folder 
   iii. Copy **messaging.json.sample** to the NSIWS config folder and remove **sample** suffix from the filename and update the values according your installation. 
   iiii. Verify that the plugin is working by uploading a DSD using the NSIWS rest interface, this should create all database objects in the Dotstat data database.

3. How to persist queue data to not loose any data setting of the queue in case of using Docker? Map volumes as seen in the example below.

    rabbit-mq:
        image: rabbitmq:3.8.9-management
        container_name: rabbit-mq
        hostname: my-rabbit-mq
        ports:
          - "15672:15672"
          - "5672:5672"
        volumes:
          - "./rabbitmq/data/:/var/lib/rabbitmq/mnesia/"    #data 
          - "./logs:/var/log/rabbitmq/log"     #logs
        networks:
          - my_network

